//
//  ViewController.m
//  Waver
//
//  Created by kevinzhow on 14/12/14.
//  Copyright (c) 2014年 Catch Inc. All rights reserved.
//

#import "VoiceWaveViewController.h"
#import "Waver.h"
#import <AVFoundation/AVFoundation.h>

@interface VoiceWaveViewController ()
{
    
}


@end

@implementation VoiceWaveViewController

- (void)viewDidLoad {
    
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor blackColor];
    //输入识别语音动画；
    _recognizeImgView =  [[UIImageView alloc] initWithFrame:CGRectMake(-100,CGRectGetHeight(self.view.bounds) - 400.0, 80, 40.0)];
    _recognizeImgView.image = [UIImage imageNamed:@"voice_ic_dengdai"];
    [self.view addSubview:_recognizeImgView];
    //语音输入动画
    _recordingWaverView = [[Waver alloc] initWithFrame:CGRectMake(0, 0, [UIScreen mainScreen].bounds.size.width, 100.0)];
    __block AVAudioRecorder *weakRecorder = self.recorder;
    _recordingWaverView.waverLevelCallback = ^(Waver * waver) {
    [weakRecorder updateMeters];
     CGFloat normalizedValue = pow (10, [weakRecorder averagePowerForChannel:0] / 40);
    waver.level = normalizedValue;
    };
    [_recordingWaverView addTarget:self action:@selector(waverclick) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:_recordingWaverView];
    //底部语音view
    _mymicView = [[UIView alloc]initWithFrame: CGRectMake(0, 0, [UIScreen mainScreen].bounds.size.width, 100.0)];
    [self.view addSubview:_mymicView];
     _mymicView.backgroundColor = [UIColor blackColor];
    UIImageView *micimg = [[UIImageView alloc]initWithFrame:CGRectMake([UIScreen mainScreen].bounds.size.width/2-15, 40, 30, 30.0)];
    [_mymicView addSubview: micimg];
    micimg.image = [UIImage imageNamed: @"voice_ic_mic"];
    //语音按钮
    _voiceBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    _voiceBtn.frame = CGRectMake(0, 0,  600, 100.0);
    _voiceBtn.backgroundColor = [UIColor clearColor];
    [_voiceBtn addTarget:self action:@selector(voicebtnclick) forControlEvents:UIControlEventTouchUpInside];
    [_mymicView addSubview:_voiceBtn];
    
    
}

-(void)voicebtnclick
{
    _myVoiceState = VoiceBeginState;
    [self selectMyVoiceState:_myVoiceState];
    
}

-(void)waverclick
{
    _myVoiceState = VoiceRecognizeState;
    [self selectMyVoiceState:_myVoiceState];
}
-(void)voiceRecognize
{
    _recordingWaverView.hidden = YES;
    _recognizeImgView.hidden = NO;
    _recognizeImgView.frame =  CGRectMake(100,35, 257/2, 19/2);
    
    
    //1.创建核心动画
    CAKeyframeAnimation *keyAnima=[CAKeyframeAnimation animation];
    //平移
    keyAnima.keyPath=@"position";
    //1.1告诉系统要执行什么动画
    CGFloat animationheigh = 35;
    NSValue *value1=[NSValue valueWithCGPoint:CGPointMake(CGRectGetWidth(self.view.bounds)/4, animationheigh)];
    NSValue *value2=[NSValue valueWithCGPoint:CGPointMake(CGRectGetWidth(self.view.bounds)/2, animationheigh)];
    NSValue *value3=[NSValue valueWithCGPoint:CGPointMake(CGRectGetWidth(self.view.bounds)*3/4, animationheigh)];
    NSValue *value4=[NSValue valueWithCGPoint:CGPointMake(CGRectGetWidth(self.view.bounds)/4, animationheigh)];
    
    
    keyAnima.values = @[value1,value2,value3,value4];
    //1.2设置动画执行完毕后，不删除动画
    keyAnima.removedOnCompletion=YES;
    //1.3设置保存动画的最新状态
    keyAnima.fillMode=kCAFillModeRemoved;
    //1.4设置动画执行的时间
    keyAnima.duration=2.0;
    //1.5设置动画的节奏
    keyAnima.timingFunction=[CAMediaTimingFunction functionWithName:kCAMediaTimingFunctionEaseInEaseOut];
    
    //设置代理，开始—结束
    keyAnima.delegate=self;
    //2.添加核心动画
    [_recognizeImgView.layer addAnimation:keyAnima forKey:nil];
   

}

-(void)voiceBegin
{
    [self.view sendSubviewToBack:_mymicView];
    [self.view bringSubviewToFront:_recordingWaverView];
    _mymicView.hidden = YES;
    _recordingWaverView.hidden = NO;
}
-(void)voiceStop
{
    _myVoiceState = VoiceStopState;
    _recognizeImgView.hidden = YES;
    _mymicView.hidden = NO;
    [self.view bringSubviewToFront:_mymicView];
}

- (void)animationDidStop:(CAAnimation *)anim finished:(BOOL)flag;

{
    
    _myVoiceState = VoiceStopState;
    [self selectMyVoiceState:_myVoiceState];
    
    
}

-(void)selectMyVoiceState:(VoiceTypeState)aVoiceType
{

    switch ( aVoiceType) {
        case  VoiceStopState:
            
            [self voiceStop];
            break;
            
        case  VoiceBeginState:
            [self voiceBegin];
            break;
            
        case  VoiceRecognizeState:
            [self voiceRecognize];
            break;
            
            
        default:
            break;
    }
 
}


- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    
}

@end
